//磁場中での荷電粒子の運動
#include <stdio.h>
#include <math.h>

#define PARTICLE_NUMBER 1
const double e = 1.0; // Elementary charge (Coulomb)
const double m_pr = 1.0; // Proton mass (kg)
const double m_el = 0.1; // Electron mass (kg)
const double Bx = 0.0; // Tesla
const double By = 0.0;
const double Bz = 1.0;

struct particle {
    double m[PARTICLE_NUMBER]; // mass
    double x[PARTICLE_NUMBER];
    double y[PARTICLE_NUMBER];
    double z[PARTICLE_NUMBER];
    double vx[PARTICLE_NUMBER];
    double vy[PARTICLE_NUMBER];
    double vz[PARTICLE_NUMBER];
};

int main(void) {
    double t=0.0, dt=0.01;
    struct particle p;

    for (int j=0; j<PARTICLE_NUMBER; j++) {
        FILE *fp;
        fp=fopen("aurora1.txt", "w");
        fprintf(fp, "#x\t\ty\t\tz\n");

        double t=0.0, dt=0.01;
        struct particle p;
        p.m[j]=m_pr;
        p.x[j]=3.0;
        p.y[j]=0.0;
        p.z[j]=0.0;
        p.vx[j]=0.0;
        p.vy[j]=-3.0;
        p.vz[j]=0.0; // 1.0

        for (int i=0; i<=1000; i++) {
            t=i*dt;
            fprintf(fp, "%f\t%f\t%f\n", p.x[j], p.y[j], p.z[j]);
            // Runge-Kutta coefficients
            double k1x, k1y, k1z, k1vx, k1vy, k1vz;
            double k2x, k2y, k2z, k2vx, k2vy, k2vz;
            double k3x, k3y, k3z, k3vx, k3vy, k3vz;
            double k4x, k4y, k4z, k4vx, k4vy, k4vz;
            double vxtmp, vytmp, vztmp;

            vxtmp = p.vx[j];
            vytmp = p.vy[j];
            vztmp = p.vz[j];
            k1x=dt*(vxtmp);
            k1y=dt*(vytmp);
            k1z=dt*(vztmp);
            k1vx=dt*e/p.m[j]*(vytmp*Bz-vztmp*By);
            k1vy=dt*e/p.m[j]*(vztmp*Bx-vxtmp*Bz);
            k1vz=dt*e/p.m[j]*(vxtmp*By-vytmp*Bx);

            vxtmp = p.vx[j]+k1vx/2.0;
            vytmp = p.vy[j]+k1vy/2.0;
            vztmp = p.vz[j]+k1vz/2.0;
            k2x=dt*(vxtmp);
            k2y=dt*(vytmp);
            k2z=dt*(vztmp);
            k2vx=dt*e/p.m[j]*(vytmp*Bz-vztmp*By);
            k2vy=dt*e/p.m[j]*(vztmp*Bx-vxtmp*Bz);
            k2vz=dt*e/p.m[j]*(vxtmp*By-vytmp*Bx);

            vxtmp = p.vx[j]+k2vx/2.0;
            vytmp = p.vy[j]+k2vy/2.0;
            vztmp = p.vz[j]+k2vz/2.0;
            k3x=dt*(vxtmp);
            k3y=dt*(vytmp);
            k3z=dt*(vztmp);
            k3vx=dt*e/p.m[j]*(vytmp*Bz-vztmp*By);
            k3vy=dt*e/p.m[j]*(vztmp*Bx-vxtmp*Bz);
            k3vz=dt*e/p.m[j]*(vxtmp*By-vytmp*Bx);

            vxtmp = p.vx[j]+k3vx;
            vytmp = p.vy[j]+k3vy;
            vztmp = p.vz[j]+k3vz;
            k4x=dt*(vxtmp);
            k4y=dt*(vytmp);
            k4z=dt*(vztmp);
            k4vx=dt*e/p.m[j]*(vytmp*Bz-vztmp*By);
            k4vy=dt*e/p.m[j]*(vztmp*Bx-vxtmp*Bz);
            k4vz=dt*e/p.m[j]*(vxtmp*By-vytmp*Bx);

            p.x[j]=p.x[j]+(k1x + 2.0*k2x + 2.0*k3x + k4x)/6.0;
            p.y[j]=p.y[j]+(k1y + 2.0*k2y + 2.0*k3y + k4y)/6.0;
            p.z[j]=p.z[j]+(k1z + 2.0*k2z + 2.0*k3z + k4z)/6.0;
            p.vx[j]=p.vx[j]+(k1vx + 2.0*k2vx + 2.0*k3vx + k4vx)/6.0;
            p.vy[j]=p.vy[j]+(k1vy + 2.0*k2vy + 2.0*k3vy + k4vy)/6.0;
            p.vz[j]=p.vz[j]+(k1vz + 2.0*k2vz + 2.0*k3vz + k4vz)/6.0;
        }
        fclose(fp);
    }

    return 0;
}
