//地球の磁場3次元
#include <stdio.h>
#include <math.h>

#define N 7 //分割数7

int main(void) {
    double Btheta, Br;
    double mu0=1.0, m=1.0, r, sintheta, costheta, sinphi, cosphi;
    double h=20.0/(N-1); // 3.3
    double x, y, R, z, Bx, By, BR, Bz;
    double omega=0.0; // 23.4
    double rotate[2][2];
    rotate[0][0]=cos(omega*M_PI/180);
    rotate[0][1]=-sin(omega*M_PI/180);
    rotate[1][0]=sin(omega*M_PI/180);
    rotate[1][1]=cos(omega*M_PI/180);
    double x_new, z_new, Bx_new, Bz_new;

    FILE *fp;
    fp=fopen("aurora3.txt", "w");
    fprintf(fp, "#x\t\ty\t\tz\t\tBx\t\tBy\t\tBz\n");

    for (int j=0; j<N; j++) {
        for (int k=0; k<N; k++) {
            for (int i=0; i<N; i++) {
                x=-10.0+h*i;
                y=10.0-h*j;
                z=10.0-h*k;
                x_new=x*rotate[0][0]+z*rotate[0][1];
                z_new=x*rotate[1][0]+z*rotate[1][1];
                x=x_new;
                z=z_new;
                R=x*x+y*y;
                R=sqrt(R);
                if (R!=0) {
                    sinphi=y/R;
                    cosphi=x/R;
                } else {
                    sinphi=0.0;
                    cosphi=0.0;
                }
                r=R*R+z*z;
                r=sqrt(r);
                if (r!=0) {
                    sintheta=R/r; //回転半径Rを使う
                    costheta=z/r;
                    Btheta=mu0*m*sintheta/(4*M_PI*r*r*r);
                    Br=mu0*2*m*costheta/(4*M_PI*r*r*r);
                } else {
                    sintheta=0.0;
                    costheta=0.0;
                    Btheta=0.0;
                    Br=0.0;
                }
                BR=Btheta*costheta+Br*sintheta;
                Bz=Btheta*(-sintheta)+Br*costheta;

                Bx=BR*cosphi;
                By=BR*sinphi;

                //逆回転行列
                x_new=x*rotate[0][0]+z*rotate[1][0];
                z_new=x*rotate[0][1]+z*rotate[1][1];
                Bx_new=Bx*rotate[0][0]+Bz*rotate[1][0];
                Bz_new=Bx*rotate[0][1]+Bz*rotate[1][1];
                x=x_new;
                z=z_new;
                Bx=Bx_new;
                Bz=Bz_new;
                fprintf(fp, "%f\t%f\t%f\t%f\t%f\t%f\n", x, y, z, Bx*(-1), By*(-1), Bz*(-1));
            }
        }
    }

    fclose(fp);

    return 0;
}
